grk::TileCodingParams Struct Reference

Tile coding parameters : this structure is used to store coding/decoding parameters common to all tiles (information like COD, COC in main header) More...

`#include <CodingParams.h>`

## Public Member Functions

| TileCodingParams ()
| ~TileCodingParams ()
bool | advanceTilePartCounter (uint16_t tileIndex, uint8_t tilePartIndex)
bool | copy (const TileCodingParams *rhs, const GrkImage *image)
void | setIsHT (bool ht, bool reversible, uint8_t guardBits)
bool | isHT (void)
uint32_t | getNumProgressions (void)
bool | hasPoc (void)

## Public Attributes

uint8_t | csty
| coding style
GRK_PROG_ORDER | prg
| progression order
uint16_t | numlayers
| number of layers
uint16_t | numLayersToDecompress
uint8_t | mct
| multi-component transform identifier
double | rates [maxCompressLayersGRK]
| rates of layers
uint32_t | numpocs
| number of progression order changes
grk_progression | progressionOrderChange [GRK_J2K_MAXRLVLS]
| progression order changes
uint32_t | ppt_markers_count
| number of ppt markers (reserved size)
grk_ppx * | ppt_markers
| ppt markers data (table indexed by Zppt)
uint8_t * | ppt_data
| packet header store there for future use in t2_decode_packet
uint8_t * | ppt_buffer
| used to keep a track of the allocated memory
size_t | ppt_data_size
| Number of bytes stored inside ppt_data.
size_t | ppt_len
| size of ppt_data
double | distortion [maxCompressLayersGRK]
| fixed_quality
uint32_t | main_qcd_qntsty
uint32_t | main_qcd_numStepSizes
TileComponentCodingParams * | tccps
| tile-component coding parameters
uint8_t | tilePartCounter_
uint8_t | numTileParts_
| number of tile parts for the tile.
SparseBuffer * | compressedTileData_
double * | mct_norms
| compressing norms
float * | mct_decoding_matrix_
| the mct decoding matrix
float * | mct_coding_matrix_
| the mct coding matrix
grk_mct_data * | mct_records_
| mct records
uint32_t | nb_mct_records_
| the number of mct records.
uint32_t | nb_max_mct_records_
| the max number of mct records.
grk_simple_mcc_decorrelation_data * | mcc_records_
| mcc records
uint32_t | nb_mcc_records_
| the number of mct records.
uint32_t | nb_max_mcc_records_
| the max number of mct records.
bool | cod
| If cod == true --> there was a COD marker for the present tile.
bool | ppt
| If ppt == true --> there was a PPT marker for the present tile.
Quantizer * | qcd_

## Private Attributes

bool | ht_

## Detailed Description

Tile coding parameters : this structure is used to store coding/decoding parameters common to all tiles (information like COD, COC in main header)

## Constructor & Destructor Documentation

## TileCodingParams()

grk::TileCodingParams::TileCodingParams | ( |  | ) |

References distortion, grk::grk_read(), grk::maxCompressLayersGRK, progressionOrderChange, and rates.

## ~TileCodingParams()

grk::TileCodingParams::~TileCodingParams | ( |  | ) |

References compressedTileData_, grk::grk_free(), grk::grk_read(), mcc_records_, mct_coding_matrix_, mct_decoding_matrix_, mct_norms, mct_records_, nb_mct_records_, ppt_buffer, ppt_markers, ppt_markers_count, qcd_, and tccps.

## Member Function Documentation

## advanceTilePartCounter()

bool grk::TileCodingParams::advanceTilePartCounter | ( | uint16_t | tileIndex,
|  | uint8_t | tilePartIndex
| ) |  |

References grk::GRK_ERROR(), grk::grk_read(), and tilePartCounter_.

## copy()

bool grk::TileCodingParams::copy | ( | const TileCodingParams * | rhs,
|  | const GrkImage * | image
| ) |  |

References cod, grk::grk_mct_data::data_, grk::grk_simple_mcc_decorrelation_data::decorrelation_array_, grk::grk_malloc(), grk::grk_read(), mcc_records_, mct_decoding_matrix_, mct_records_, nb_max_mcc_records_, nb_max_mct_records_, _grk_image::numcomps, ppt, ppt_data, qcd_, and tccps.

## getNumProgressions()

uint32_t grk::TileCodingParams::getNumProgressions | ( | void |  | ) |

References numpocs.

Referenced by grk::TileProcessor::doCompress().

## hasPoc()

bool grk::TileCodingParams::hasPoc | ( | void |  | ) |

References numpocs.

Referenced by grk::TileProcessor::canWritePocMarker(), and grk::CodeStreamCompress::init_header_writing().

## isHT()

bool grk::TileCodingParams::isHT | ( | void |  | ) |

References ht_.

Referenced by grk::CodeStreamCompress::init_header_writing(), and grk::PacketParser::readData().

## setIsHT()

void grk::TileCodingParams::setIsHT | ( | bool | ht,
|  | bool | reversible,
|  | uint8_t | guardBits
| ) |  |

References grk::grk_read(), ht_, grk::T1Factory::makeQuantizer(), and qcd_.

## Member Data Documentation

## cod

bool grk::TileCodingParams::cod

If cod == true --> there was a COD marker for the present tile.

Referenced by copy().

## compressedTileData_

SparseBuffer* grk::TileCodingParams::compressedTileData_

Referenced by ~TileCodingParams().

## csty

uint8_t grk::TileCodingParams::csty

coding style

Referenced by grk::PacketParser::readHeader().

## distortion

double grk::TileCodingParams::distortion[maxCompressLayersGRK]

fixed_quality

Referenced by grk::TileProcessor::layerNeedsRateControl(), grk::TileProcessor::pcrdBisectSimple(), and TileCodingParams().

## ht_

bool grk::TileCodingParams::ht_

private

Referenced by isHT(), and setIsHT().

## main_qcd_numStepSizes

uint32_t grk::TileCodingParams::main_qcd_numStepSizes

## main_qcd_qntsty

uint32_t grk::TileCodingParams::main_qcd_qntsty

## mcc_records_

grk_simple_mcc_decorrelation_data* grk::TileCodingParams::mcc_records_

mcc records

Referenced by copy(), and ~TileCodingParams().

## mct

uint8_t grk::TileCodingParams::mct

multi-component transform identifier

Referenced by grk::TileProcessor::decompressT2T1(), grk::TileProcessor::mct_encode(), grk::TileProcessor::mctDecompress(), and grk::TileProcessor::needsMctDecompress().

## mct_coding_matrix_

float* grk::TileCodingParams::mct_coding_matrix_

the mct coding matrix

Referenced by grk::TileProcessor::mct_encode(), and ~TileCodingParams().

## mct_decoding_matrix_

float* grk::TileCodingParams::mct_decoding_matrix_

the mct decoding matrix

Referenced by copy(), grk::TileProcessor::mctDecompress(), grk::TileProcessor::needsMctDecompress(), and ~TileCodingParams().

## mct_norms

double* grk::TileCodingParams::mct_norms

compressing norms

Referenced by ~TileCodingParams().

## mct_records_

grk_mct_data* grk::TileCodingParams::mct_records_

mct records

Referenced by copy(), grk::CodeStreamCompress::write_mct_data_group(), and ~TileCodingParams().

## nb_max_mcc_records_

uint32_t grk::TileCodingParams::nb_max_mcc_records_

the max number of mct records.

Referenced by copy().

## nb_max_mct_records_

uint32_t grk::TileCodingParams::nb_max_mct_records_

the max number of mct records.

Referenced by copy().

## nb_mcc_records_

uint32_t grk::TileCodingParams::nb_mcc_records_

the number of mct records.

## nb_mct_records_

uint32_t grk::TileCodingParams::nb_mct_records_

the number of mct records.

Referenced by ~TileCodingParams().

## numlayers

uint16_t grk::TileCodingParams::numlayers

number of layers

Referenced by grk::TileProcessor::encodeT2(), grk::TileProcessor::makeSingleLosslessLayer(), grk::TileProcessor::needsRateControl(), grk::TileProcessor::pcrdBisectFeasible(), grk::TileProcessor::pcrdBisectSimple(), and grk::PrecinctPacketParsers::PrecinctPacketParsers().

## numLayersToDecompress

uint16_t grk::TileCodingParams::numLayersToDecompress

Referenced by grk::PacketIter::init(), and grk::T2Decompress::processPacket().

## numpocs

uint32_t grk::TileCodingParams::numpocs

number of progression order changes

Referenced by getNumProgressions(), hasPoc(), and grk::PacketManager::PacketManager().

## numTileParts_

uint8_t grk::TileCodingParams::numTileParts_

number of tile parts for the tile.

## ppt

bool grk::TileCodingParams::ppt

If ppt == true --> there was a PPT marker for the present tile.

Referenced by copy().

## ppt_buffer

uint8_t* grk::TileCodingParams::ppt_buffer

used to keep a track of the allocated memory

Referenced by ~TileCodingParams().

## ppt_data

uint8_t* grk::TileCodingParams::ppt_data

packet header store there for future use in t2_decode_packet

Referenced by copy().

## ppt_data_size

size_t grk::TileCodingParams::ppt_data_size

Number of bytes stored inside ppt_data.

## ppt_len

size_t grk::TileCodingParams::ppt_len

size of ppt_data

## ppt_markers

grk_ppx* grk::TileCodingParams::ppt_markers

ppt markers data (table indexed by Zppt)

Referenced by ~TileCodingParams().

## ppt_markers_count

uint32_t grk::TileCodingParams::ppt_markers_count

number of ppt markers (reserved size)

Referenced by ~TileCodingParams().

## prg

GRK_PROG_ORDER grk::TileCodingParams::prg

progression order

## progressionOrderChange

grk_progression grk::TileCodingParams::progressionOrderChange[GRK_J2K_MAXRLVLS]

progression order changes

Referenced by TileCodingParams().

## qcd_

Quantizer* grk::TileCodingParams::qcd_

Referenced by copy(), setIsHT(), grk::CodeStreamCompress::write_cap(), and ~TileCodingParams().

## rates

double grk::TileCodingParams::rates[maxCompressLayersGRK]

rates of layers

Referenced by grk::TileProcessor::layerNeedsRateControl(), grk::TileProcessor::pcrdBisectSimple(), and TileCodingParams().

## tccps

TileComponentCodingParams* grk::TileCodingParams::tccps

tile-component coding parameters

Referenced by grk::CodeStreamCompress::compare_SPCod_SPCoc(), grk::CodeStreamCompress::compare_SQcd_SQcc(), grk::CodeStreamCompress::compressValidation(), copy(), grk::TileProcessor::dcLevelShiftCompress(), grk::TileProcessor::decompressT2T1(), grk::TileProcessor::dwt_encode(), grk::CodeStreamCompress::get_SPCod_SPCoc_size(), grk::CodeStreamCompress::get_SQcd_SQcc_size(), grk::TileProcessor::getMaxNumDecompressResolutions(), grk::CodeStreamCompress::init(), grk::TileProcessor::mct_encode(), grk::CodeStreamCompress::mct_validation(), grk::TileProcessor::mctDecompress(), grk::SIZMarker::read(), grk::CodeStreamDecompress::readHeader(), grk::CompressScheduler::scheduleBlocks(), grk::DecompressScheduler::scheduleBlocks(), grk::DecompressScheduler::scheduleWavelet(), grk::CodeStreamCompress::write_regions(), grk::CodeStreamCompress::write_SPCod_SPCoc(), grk::CodeStreamCompress::write_SQcd_SQcc(), grk::CodeStreamCompress::writePoc(), and ~TileCodingParams().

## tilePartCounter_

uint8_t grk::TileCodingParams::tilePartCounter_

Referenced by advanceTilePartCounter(), grk::CodeStreamDecompress::decompressTile(), and grk::TileLengthMarkers::seek().

The documentation for this struct was generated from the following files:

- CodingParams.h
- CodingParams.cpp